freeslot("SPR_SHOK","SPR_HMDP","S_SSNTHOK","S_PLAY_HAMMERDROP","MT_SSNTHOK")

mobjinfo[MT_SSNTHOK] = {
	doomednum = -1,
	spawnstate = S_SSNTHOK,
	spawnhealth = 1,
	radius = 32*FRACUNIT,
	height = 64*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY
}

states[S_SSNTHOK] = {SPR_SHOK,A|TR_TRANS60,8,A_None,0,0,S_NULL}
states[S_PLAY_HAMMERDROP] = {SPR_HMDP,A,-1,A_None,0,0,S_PLAY_FALL}

//Walljump lua first so we can check if the player is clinging or not first
addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.skin == "ssnmighty")
			
			//if not (player.atwall)
				player.atwall = 0
			//end
			if not (player.cling)
				player.cling = false
			end
			if not (player.clingprev)
				player.clingprev = false
			end
			if (player.mo) //Fixes spectating, and possibly other things
				//Finding walls (not FOFs)
				local wall = R_PointInSubsector(player.mo.x+FixedMul(26*FRACUNIT, cos(player.mo.angle)), player.mo.y+FixedMul(26*FRACUNIT, sin(player.mo.angle))).sector
				local fheight = wall.floorheight
				local cheight = wall.ceilingheight

				if wall.f_slope then
					fheight = P_GetZAt(wall.f_slope, player.mo.x + player.mo.momx, player.mo.y + player.mo.momy)
				end
				if wall.c_slope then
					cheight = P_GetZAt(wall.c_slope, player.mo.x + player.mo.momx, player.mo.y + player.mo.momy)
				end
				
				if (fheight > player.mo.z) or ((cheight <= player.mo.height+player.mo.z) and not (fheight == cheight)/* and (wall.ceilingpic == "F_SKY1")*/) //This last bit seems to be broken...
					player.atwall = 1
				end
				//FOFs can be walls too, so lets check for those
				for wall in wall.ffloors()
					if (player.mo.z <= wall.topheight) and (player.mo.height+player.mo.z > wall.bottomheight)
						and(wall.flags & FF_BLOCKPLAYER) //Don't want the player to cling to water. That would be stupid
						player.atwall = $1 + 1
					end		
				end
				if(player.atwall <= 0)
					if (player.cling)
						player.pflags = $1&~PF_JUMPED
						player.mo.state = S_PLAY_FALL
					end
					player.cling = false
				end	
				if (P_IsObjectOnGround(player.mo))
					player.cling = false
				end	
				//This allows sonic to thok away from a wall. You can remove this if you dont want your character to do this.
				//Lazy checks
				if (player.powers[pw_carry] == CR_NONE)
				and not (player.pflags & PF_THOKKED) 
				and not (player.charability2 == CA2_MULTIABILITY)
					//If you're clinging to a wall
					if (player.cling)
						and not (player.cmd.buttons & BT_JUMP)
						if (player.powers[pw_underwater])
							P_SetObjectMomZ(player.mo, 10*FRACUNIT)
						else
							P_SetObjectMomZ(player.mo, 15*FRACUNIT)
						end
						S_StartSound(player.mo, sfx_jump)
						player.cling = false
						if (player.charability2 == CA2_SPINDASH)
							player.mo.state = S_PLAY_ROLL //L
						else
							player.mo.state = S_PLAY_SPRING //P
						end
						player.jumping = false
						P_InstaThrust(player.mo, player.mo.angle, -player.actionspd/3) //Devided by 3 for sonic, but you can remove this for your character
						player.mo.angle = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
					end
					//Cling onto a wall
					if (player.atwall > 0)
						and (((player.mo.momz < -3*FRACUNIT+1) and not (player.mo.flags2 & MF2_OBJECTFLIP)) or ((player.mo.momz > 3*FRACUNIT-1) and (player.mo.flags2 & MF2_OBJECTFLIP)))
						and (player.pflags & PF_JUMPED)
						and (player.cmd.buttons & BT_JUMP)
						and not (player.exiting)
						P_SetObjectMomZ(player.mo, -3*FRACUNIT)
						player.mo.momx = $1 / 2
						player.mo.momy = $1 / 2
						player.mo.state = S_PLAY_WALK //F
						player.mo.frame = 3
						player.cling = true
						if (player.clingprev == false)
							S_StartSound(player.mo,sfx_s3k4a)
						end
						if not (S_SoundPlaying(player.mo,sfx_s3k7e))
							S_StartSound(player.mo, sfx_s3k7e)
						end
					end
				end			
				//Movement fix
				if (player.cling)
					player.normalspeed = 0
				else 
					player.normalspeed = skins[player.mo.skin].normalspeed
				end
				player.clingprev = player.cling	
			end		
		end
	end
end)

addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.valid and player.mo.skin == "ssnmighty"
			//init
			if not (player.hammer)
				player.hammer = false
			end
			if not (player.justhammer)
				player.justhammer = false
			end
			if not (player.canhammer)
				player.canhammer = true
			end
			if not (player.bounce)
				player.bounce = false
			end
			if not (player.hammertimer)
				player.hammertimer = 0
			end
			//actual code for the ability now
			
			//seperated from the second check since i dunno who does it
			if P_IsObjectOnGround(player.mo) and (player.hammer == true)
				for x=player.mo.x,player.mo.x+player.mo.radius,player.mo.radius
					for y=player.mo.y,player.mo.y+player.mo.radius,player.mo.radius
						local ss = R_PointInSubsector(x,y)
						for fof in ss.sector.ffloors()
							if (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
								if (player.mo.z+player.mo.momz==fof.topheight or player.mo.z+player.mo.height+player.mo.momz==fof.bottomheight or (player.mo.eflags & MFE_VERTICALFLIP and (player.mo.z+player.mo.momz==fof.bottomheight or player.mo.z-player.mo.height-player.mo.momz==fof.topheight)))
									EV_CrumbleChain(ss.sector, fof)
									player.hammer = true
									player.mo.momz = -32*FRACUNIT*P_MobjFlip(player.mo)
									player.mo.state = S_PLAY_HAMMERDROP
								end
							end
						end
					end
				end
			end
			
			if (player.hammer == true)
				if (player.powers[pw_carry] ~= CR_NONE) or (player.powers[pw_justsprung]) or (P_IsObjectInGoop(player.mo)) or (player.mo.health == 0) or (player.hammertimer >= 5*TICRATE) or (player.cling == true) or (player.atwall == 1)
					player.hammer = false
					player.canhammer = false
					player.justhammer = true
					player.hammertimer = 0
					if (P_IsObjectInGoop(player.mo)) or (player.hammertimer >= 5*TICRATE)
					player.mo.state = S_PLAY_FALL
					elseif (player.powers[pw_justsprung])
						player.mo.momz = $ * 125/100
						S_StartSound(player.mo, sfx_sprong)
					end
					return
				end
				if (player.atwall == 0)
					P_InstaThrust(player.mo, player.mo.angle, 0)
					player.hammertimer = $ + 1
					player.mo.momz = -32*FRACUNIT*P_MobjFlip(player.mo)
					player.mo.state = S_PLAY_HAMMERDROP
					P_SpawnGhostMobj(player.mo)
					if P_IsObjectOnGround(player.mo)
						local cursec = R_PointInSubsector(player.mo.x + player.mo.momx, player.mo.y + player.mo.momy).sector
						for rov in cursec.ffloors()
							if not (cursec.f_slope) continue end
							local spd = 24
							if (player.powers[pw_underwater]) spd = 12 end
							P_InstaThrust(player.mo, cursec.f_slope.xydirection, spd*FRACUNIT)
						end
						player.mo.state = S_PLAY_FALL
						player.mo.momz = 8*FRACUNIT
						player.hammertimer = 0
						P_StartQuake(30*FRACUNIT, 10)
						S_StartSound(player.mo, sfx_rocks1)
						player.justhammer = true
						P_NukeEnemies(player.mo, player.mo, 125*FRACUNIT)
						for i = 1, 32
							local dust = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + (player.mo.eflags & MFE_VERTICALFLIP and 4*player.mo.scale or 0), player.mo.eflags & (MFE_UNDERWATER | MFE_TOUCHWATER) and MT_MEDIUMBUBBLE or MT_PARTICLE)
							dust.fuse = TICRATE/2
							dust.scale = player.mo.scale*2
							dust.destscale = player.mo.scale/8
							P_InstaThrust(dust, i*ANG10+ANG1, 4*player.mo.scale)
							dust.frame = $1|TR_TRANS60
						end
						player.hammer = false
					end
				end
			end
			if (player.justhammer == true) and P_IsObjectOnGround(player.mo)
				player.justhammer = false
				player.canhammer = true
				player.hammertimer = 0
			end
			if P_IsObjectOnGround(player.mo)
				player.bounce = false
			end
		end
	end
end)

addHook("ShouldDamage", function(mobj, spike)
    if (mobj.player and mobj.skin == "ssnmighty")
		if (spike == nil) return end
		if (spike.valid and spike.type == MT_SPIKE)
			if (mobj.player.hammer == true)
				spike.health = 0
				S_StartSound(mobj, spike.info.deathsound)
				P_KillMobj(spike, mobj, mobj)
				return false
			elseif (mobj.player.bounce == false) and (mobj.player.hammer == false)
				mobj.player.pflags = $1 & ~PF_SPINNING
				mobj.momz = 10*FRACUNIT
				mobj.momx = FixedMul(-8*FRACUNIT, cos(mobj.angle))
				mobj.momy = FixedMul(-8*FRACUNIT, sin(mobj.angle))
				S_StartSound(target, sfx_s3k44)
				mobj.state = S_PLAY_FALL
				mobj.player.bounce = true
				return false
			end
		elseif (spike.valid and ((spike.flags & MF_MISSILE and spike.flags & MF_ENEMY) or (spike.type == MT_ARROW)) and (mobj.state == S_PLAY_JUMP or mobj.state == S_PLAY_ROLL or mobj.state == S_PLAY_SPINDASH)) then
			S_StartSound(spike, sfx_bnce1, mobj.player)
			spike.momx = ($1*-2) + (P_RandomRange(-10, 10) * FRACUNIT)
			spike.momy = ($1*-2) + (P_RandomRange(-10, 10) * FRACUNIT)
			spike.momz = ($1*-2) + (P_RandomRange(-10, 10) * FRACUNIT)
			spike.flags = $1|MF_NOCLIPTHING
			spike.flags = $1|MF_NOCLIP
			return false
		end
	end
end)

addHook("AbilitySpecial", function(player)
	if not (player.mo.skin == "ssnmighty") return end
	if (player.canhammer == false) return end
	if P_PlayerInPain(player) return end
	if P_IsObjectInGoop(player.mo) return end
	if (player.hammer == true) return end
	if (player.atwall == 0)
		S_StartSound(player.mo, sfx_zoom)
	end
	player.hammer = true
	player.canhammer = false
	return true
end)